Attribute VB_Name = "FileURL"
Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type
Public Const MAX_PATH = 260
Enum File_Attributes
    FILE_ATTRIBUTE_ARCHIVE = &H20
    FILE_ATTRIBUTE_COMPRESSED = &H800
    FILE_ATTRIBUTE_DIRECTORY = &H10
    FILE_ATTRIBUTE_HIDDEN = &H2
    FILE_ATTRIBUTE_NORMAL = &H80
    FILE_ATTRIBUTE_READONLY = &H1
    FILE_ATTRIBUTE_SYSTEM = &H4
    FILE_ATTRIBUTE_TEMPORARY = &H100
End Enum

Type WIN32_FIND_DATA
    dwFileAttributes As Long 'File_Attributes
    ftCreationTime As FILETIME
    ftLastAccessTime As FILETIME
    ftLastWriteTime As FILETIME
    nFileSizeHigh As Long
    nFileSizeLow As Long
    dwReserved0 As Long
    dwReserved1 As Long
    cFileName As String * MAX_PATH
    cAlternate As String * 14
End Type

Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA) As Long
Declare Function FindNextFile Lib "kernel32" Alias "FindNextFileA" (ByVal hFindFile As Long, lpFindFileData As WIN32_FIND_DATA) As Long
Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Long) As Long


Function TopDIR(ByVal Paths As String) As String
Dim LastBit As Long
Dim LastBit1 As Long
LastBit = InStr(1, Paths, "\")

Do Until LastBit = 0
    LastBit1 = LastBit
    LastBit = InStr(LastBit1 + 1, Paths, "\")
Loop
TopDIR = Mid$(Paths, LastBit1 + 1)
End Function

Function FileFindA(ByVal SearchPath As String, Attributes As File_Attributes, ReturnArray() As String) As Long
Dim InternalArray(1024) As String
Dim Found As Integer
Dim Searchinfo As WIN32_FIND_DATA
Dim SearchHandle As Long

SearchHandle = FindFirstFile(SearchPath, Searchinfo)
Do Until Trim(Searchinfo.cFileName) = ""
    If Searchinfo.dwFileAttributes = Attributes Then
        InternalArray(Found) = Trim(Searchinfo.cFileName)
        Found = Found + 1
    End If
    Searchinfo.cFileName = ""
    FindNextFile SearchHandle, Searchinfo
Loop
FindClose SearchHandle
'ReDim ReturnArray(Found - 1)
For i = 0 To Found - 1
    ReturnArray(i) = InternalArray(i)
Next
FileFindA = Found
End Function

Function ExtractURL(Html As String, CURL$) As String
On Error Resume Next

Dim LastPos As Long
Dim URLpaths(100) As String
Dim i As Integer
Form1.Text3.Text = ""
LastPos = 1
'find the path of the HTML page and all directories
i = 0
While InStr(LastPos, CURL$, "/", vbTextCompare) <> 0
    If LastrecordedPos <> InStr(LastPos, CURL$, "/", vbTextCompare) Then
        LastrecordedPos = InStr(LastPos, CURL$, "/", vbTextCompare)
        URLpaths(i) = Mid(CURL$, 1, LastrecordedPos)
        i = i + 1
    End If
    LastPos = LastPos + 1
Wend
URLfullpath = URLpaths(i - 1)
LastPos = 0
StartOfIt:
LastPos = InStr(LastPos + 1, Html, "href", vbTextCompare)
    If LastPos <> 0 Then
        MidStart = InStr(LastPos, Html, Chr(34))
        InstStart = InStr(LastPos, Html, Chr(34))
        MidLength1 = InStr(InstStart + 1, Html, Chr(34))
        Midlenght2 = InStr(LastPos, Html, Chr(34))
        CURL$ = Mid(Html, MidStart + 1, MidLength1 - Midlenght2 - 1)
        If InStr(1, CURL$, ":", vbTextCompare) = 0 Then
            If InStr(1, CURL$, "/..", vbTextCompare) = 0 Then
            If Mid(CURL$, 1, 1) = "/" Then CURL$ = Mid(CURL$, 2)
            CURL$ = URLfullpath & CURL$
            Else
                While InStr(LastPos, CURL$, "/..", vbTextCompare) <> 0
                    If CURL$ <> Mid(CURL, InStr(LastPos, CURL$, "/..", vbTextCompare)) Then i = i - 1
                    CURL$ = Mid(CURL, LastPos)
                    LastPos = LastPos + 1
                Wend
                CURL$ = URLpaths(i) & CURL$
            End If
        End If
        
    Form1.Text3.Text = Form1.Text3.Text & CURL$ & vbLf & vbCr
    
        GoTo StartOfIt
    End If
End Function

